<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Awk</title>
<meta name="author" content="dt" />
<meta name="description" content="Knowledge Base - Awk
Header
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<script type="text/x-mathjax-config">
    MathJax.Hub.Config({
        displayAlign: "center",
        displayIndent: "0em",

        "HTML-CSS": { scale: 100,
                        linebreaks: { automatic: "false" },
                        webFont: "TeX"
                       },
        SVG: {scale: 100,
              linebreaks: { automatic: "false" },
              font: "TeX"},
        NativeMML: {scale: 100},
        TeX: { equationNumbers: {autoNumber: "AMS"},
               MultLineWidth: "85%",
               TagSide: "right",
               TagIndent: ".8em"
             }
});
</script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.0/MathJax.js?config=TeX-AMS_HTML"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Awk</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#org3a3e4e4">About Awk</a></li>
<li><a href="#orgba280a7">Basic Awk Commands</a>
<ul>
<li><a href="#org9ff5ef3">Print out file (similar to cat)</a></li>
<li><a href="#orgad36e8a">&amp;&amp; and ||</a></li>
<li><a href="#orga0c8ea0">Printing columns</a></li>
<li><a href="#orge0458c1">Filter results for search pattern</a></li>
<li><a href="#orgbfd435d">Filter results by length of line (character numbers)</a></li>
<li><a href="#org1425ee0">Find a specific string in any columns</a></li>
<li><a href="#org137cd31">Increment/Decrement</a>
<ul>
<li><a href="#orgfd42e85">Post-increment</a></li>
</ul>
</li>
<li><a href="#org4d2b680">Regex</a></li>
<li><a href="#orgfca1cba">Print substr()</a></li>
<li><a href="#orgf81fa74">Match and RSTART</a></li>
</ul>
</li>
<li><a href="#org7a855ef">Builtin Variables in Awk</a>
<ul>
<li><a href="#orgc206923">NR</a>
<ul>
<li><a href="#org7ae1b02">Print range of lines</a></li>
<li><a href="#org0e236fe">Print the line count</a></li>
</ul>
</li>
<li><a href="#orgb86baf3">NF</a></li>
<li><a href="#org3a22ea0">FS</a></li>
<li><a href="#org864e97c">RS</a></li>
<li><a href="#org3f63d4b">OFS</a></li>
<li><a href="#org379d026">ORS</a>
<ul>
<li><a href="#orgfc6ae26">Footer</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-org3a3e4e4" class="outline-2">
<h2 id="org3a3e4e4">About Awk</h2>
<div class="outline-text-2" id="text-org3a3e4e4">
<p>
Awk is a powerful text-processing utility on GNU/Linux.  It can perform complex text processing tasks, such as pulling out certain columns of information or doing substitutions.  One thing to note is that there are different variants of Awk.  On GNU/Linux distros, Awk is actually Gawk (GNU Awk).  So the package name is actually Gawk, but when you run the commands it&rsquo;s just &ldquo;awk&rdquo;.
</p>
</div>
</div>

<div id="outline-container-orgba280a7" class="outline-2">
<h2 id="orgba280a7">Basic Awk Commands</h2>
<div class="outline-text-2" id="text-orgba280a7">
<p>
awk options &rsquo;selection _criteria {action }&rsquo; input-file &gt; output-file
</p>
</div>
<div id="outline-container-org9ff5ef3" class="outline-3">
<h3 id="org9ff5ef3">Print out file (similar to cat)</h3>
<div class="outline-text-3" id="text-org9ff5ef3">
<ul class="org-ul">
<li>awk &rsquo;{print}&rsquo; test.sh</li>
<li>awk &rsquo;{print $0}&rsquo; test.sh</li>
<li>cat /etc/shells | awk &#x2026;</li>
<li>awk &#x2026; /etc/shells
=FIELD SEPARATORS</li>
<li>awk &rsquo;BEGIN{FS=&ldquo;:&rdquo;; OFS=&ldquo;-&rdquo;} {print $1,$6,$7}&rsquo; /etc/passwd</li>
<li>cat <i>etc/shells | awk &rsquo;<i>^\</i></i> {print $0}&rsquo;</li>
<li>cat <i>etc/shells | awk &rsquo;<i>^\</i></i> {print $NF}&rsquo;
awk -F &ldquo;/&rdquo; &rsquo;/^\//{print $NF}&rsquo; /etc/shells | uniq</li>
<li>awk -F &ldquo;:&rdquo; &rsquo; {print $2}&rsquo; /etc/passwd</li>
</ul>
</div>
</div>
<div id="outline-container-orgad36e8a" class="outline-3">
<h3 id="orgad36e8a">&amp;&amp; and ||</h3>
<div class="outline-text-3" id="text-orgad36e8a">
<pre class="example" id="org6ba4c42">
ps -ef | awk '/root/ &amp;&amp; $2&lt;100'
ps -ef | awk '/root/ || /dt/ &amp;&amp; (length($NF) &lt; 30)'
</pre>
</div>
</div>

<div id="outline-container-orga0c8ea0" class="outline-3">
<h3 id="orga0c8ea0">Printing columns</h3>
<div class="outline-text-3" id="text-orga0c8ea0">
<ul class="org-ul">
<li>ps -ef | head | awk &rsquo;{print $1&ldquo; &rdquo;$8}&rsquo;</li>
<li>show \t \n as alternative to just &ldquo; &rdquo;</li>
<li>show $NF instead of $8</li>
</ul>
</div>
</div>
<div id="outline-container-orge0458c1" class="outline-3">
<h3 id="orge0458c1">Filter results for search pattern</h3>
<div class="outline-text-3" id="text-orge0458c1">
<pre class="example" id="org4b93477">
/\[/
</pre>

<ul class="org-ul">
<li>df | awk &rsquo;<i>\/dev\/loop</i> {print $1&ldquo;\t&rdquo;$2&ldquo;\t&rdquo;$3}&rsquo;</li>
<li>df | awk &rsquo;<i>\/dev\/loop</i> {print $1&ldquo;\t&rdquo;$2 - $3}&rsquo;</li>
</ul>
</div>
</div>

<div id="outline-container-orgbfd435d" class="outline-3">
<h3 id="orgbfd435d">Filter results by length of line (character numbers)</h3>
<div class="outline-text-3" id="text-orgbfd435d">
<pre class="example" id="org9d22b28">
awk 'length($0) &gt; 7' /etc/shells
</pre>
</div>
</div>

<div id="outline-container-org1425ee0" class="outline-3">
<h3 id="org1425ee0">Find a specific string in any columns</h3>
<div class="outline-text-3" id="text-org1425ee0">
<pre class="example" id="orgee64d81">
ps -ef | awk '{ if($NF == "/bin/fish") print $0};'
</pre>
</div>
</div>

<div id="outline-container-org137cd31" class="outline-3">
<h3 id="org137cd31">Increment/Decrement</h3>
<div class="outline-text-3" id="text-org137cd31">
</div>
<div id="outline-container-orgfd42e85" class="outline-4">
<h4 id="orgfd42e85">Post-increment</h4>
<div class="outline-text-4" id="text-orgfd42e85">
<pre class="example" id="org4fffd5c">
awk 'BEGIN { for(i=1;i&lt;=10;i++) print "square of", i, "is",i*i; }'
</pre>
</div>
</div>
</div>

<div id="outline-container-org4d2b680" class="outline-3">
<h3 id="org4d2b680">Regex</h3>
<div class="outline-text-3" id="text-org4d2b680">
<p>
The ~ is the regular expression match operator. It checks if a string matches the provided regular expression.
</p>

<pre class="example" id="org2b5a2e2">
awk '$1 ~ /^[b,c]/ {print $0}' .bashrc
</pre>
</div>
</div>

<div id="outline-container-orgfca1cba" class="outline-3">
<h3 id="orgfca1cba">Print substr()</h3>
<div class="outline-text-3" id="text-orgfca1cba">
<p>
We use the substr() function. It prints a substring from the given string. We apply the function on each line, skipping the first three characters. In other words, we print each record from the fourth character till its end.
</p>

<pre class="example" id="org3734ff8">
awk '{print substr($0, 4)}'  numbered.txt
</pre>
</div>
</div>

<div id="outline-container-orgf81fa74" class="outline-3">
<h3 id="orgf81fa74">Match and RSTART</h3>
<div class="outline-text-3" id="text-orgf81fa74">
<p>
The match() function sets the RSTART variable; it is the index of the start of the matching pattern.
</p>

<pre class="example" id="org6fb2e28">
awk 'match($0, /o/) {print $0 " has \"o\" character at " RSTART}' numbered.txt
</pre>
</div>
</div>
</div>


<div id="outline-container-org7a855ef" class="outline-2">
<h2 id="org7a855ef">Builtin Variables in Awk</h2>
<div class="outline-text-2" id="text-org7a855ef">
</div>
<div id="outline-container-orgc206923" class="outline-3">
<h3 id="orgc206923">NR</h3>
<div class="outline-text-3" id="text-orgc206923">
<p>
NR command keeps a current count of the number of input records. Remember that records are usually lines. Awk command performs the pattern/action statements once for each record in a file.
</p>
</div>

<div id="outline-container-org7ae1b02" class="outline-4">
<h4 id="org7ae1b02">Print range of lines</h4>
<div class="outline-text-4" id="text-org7ae1b02">
<pre class="example" id="org74f9c1f">
df | awk 'NR==7, NR==11 {print NR, $0}'
NOTE: NR prints the line numbers, delete the NR if line numbers not needed!
</pre>
</div>
</div>

<div id="outline-container-org0e236fe" class="outline-4">
<h4 id="org0e236fe">Print the line count</h4>
<div class="outline-text-4" id="text-org0e236fe">
<pre class="example" id="orgd0d6384">
awk 'END {print NR}' /etc/shells
awk 'END {print NR}' /etc/shells /etc/passwd
</pre>
</div>
</div>
</div>

<div id="outline-container-orgb86baf3" class="outline-3">
<h3 id="orgb86baf3">NF</h3>
<div class="outline-text-3" id="text-orgb86baf3">
<p>
NF command keeps a count of the number of fields within the current input record. We&rsquo;ve already shown using $NF for last field.
</p>

<p>
Using NF to print all non-empty lines
</p>
<pre class="example" id="org8b98211">
awk 'NF &gt; 0' /etc/shells
</pre>
</div>
</div>

<div id="outline-container-org3a22ea0" class="outline-3">
<h3 id="org3a22ea0">FS</h3>
<div class="outline-text-3" id="text-org3a22ea0">
<p>
FS command contains the field separator character which is used to divide fields on the input line. The default is “white space”, meaning space and tab characters. FS can be reassigned to another character (typically in BEGIN) to change the field separator.
</p>
</div>
</div>
<div id="outline-container-org864e97c" class="outline-3">
<h3 id="org864e97c">RS</h3>
<div class="outline-text-3" id="text-org864e97c">
<p>
RS command stores the current record separator character. Since, by default, an input line is the input record, the default record separator character is a newline.
</p>
</div>
</div>
<div id="outline-container-org3f63d4b" class="outline-3">
<h3 id="org3f63d4b">OFS</h3>
<div class="outline-text-3" id="text-org3f63d4b">
<p>
OFS command stores the output field separator, which separates the fields when Awk prints them. The default is a blank space. Whenever print has several parameters separated with commas, it will print the value of OFS in between each parameter.
</p>
</div>
</div>
<div id="outline-container-org379d026" class="outline-3">
<h3 id="org379d026">ORS</h3>
<div class="outline-text-3" id="text-org379d026">
<p>
ORS command stores the output record separator, which separates the output lines when Awk prints them. The default is a newline character. print automatically outputs the contents of ORS at the end of whatever it is given to print.
</p>
</div>

<div id="outline-container-orgfc6ae26" class="outline-4">
<h4 id="orgfc6ae26">Footer</h4>
<div class="outline-text-4" id="text-orgfc6ae26">
<p>
Copyright © 2020-2021 Derek Taylor (DistroTube)
</p>

<p>
This page is licensed under a <a href="https://creativecommons.org/licenses/by-nd/4.0/">Creative Commons Attribution-NoDerivatives 4.0 International License</a> (CC-BY-ND 4.0).
</p>

<p>
The source code for distro.tube can be found on <a href="https://gitlab.com/dwt1/distro.tube">GitLab</a>.  User-submitted contributions to the site are welcome, as long as the contributor agrees to license their submission with the CC-BY-ND 4.0 license.
</p>
</div>
</div>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
